package com.njcn.energy.pojo.api.fallback;

import com.njcn.common.pojo.enums.response.CommonResponseEnum;
import com.njcn.common.pojo.exception.BusinessException;
import com.njcn.energy.pojo.api.EnergyStatisticFeignClient;
import com.njcn.energy.pojo.utils.EnergyEnumUtil;
import feign.hystrix.FallbackFactory;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Component;


/**
 * 类的介绍：
 *
 * @author xuyang
 * @version 1.0.0
 * @createTime 2022/4/20 15:09
 */
@Slf4j
@Component
public class EnergyStatisticFallbackFactory implements FallbackFactory<EnergyStatisticFeignClient>  {


    @Override
    public EnergyStatisticFeignClient create(Throwable cause) {
        //判断抛出异常是否为解码器抛出的业务异常
        Enum<?> exceptionEnum = CommonResponseEnum.SERVICE_FALLBACK;
        if(cause.getCause() instanceof BusinessException){
            BusinessException businessException = (BusinessException) cause.getCause();
            exceptionEnum = EnergyEnumUtil.getExceptionEnum(businessException.getResult());
        }
        Enum<?> finalExceptionEnum = exceptionEnum;
        return new EnergyStatisticFeignClient() {
            @Override
            public void electricCalJob() {
                log.error("{}异常，降级处理，异常为：{}","调度统计电量增量",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public void eleOnlineRateJobHandler() {
                log.error("{}异常，降级处理，异常为：{}","用能终端在线率数据",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }

            @Override
            public void eleIntegrityJobHandler() {
                log.error("{}异常，降级处理，异常为：{}","用能数据完整性数据",cause.toString());
                throw new BusinessException(finalExceptionEnum);
            }
        };
    }
}
